Index: protocol/src/test/java/geniusweb/protocol/session/learn/LearnTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/learn/LearnTest.java	(revision 31)
+++ protocol/src/test/java/geniusweb/protocol/session/learn/LearnTest.java	(revision 31)
@@ -0,0 +1,177 @@
+package geniusweb.protocol.session.learn;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Matchers.any;
+import static org.mockito.Matchers.isA;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.times;
+import static org.mockito.Mockito.verify;
+import static org.mockito.Mockito.when;
+
+import java.io.IOException;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.LearningDone;
+import geniusweb.actions.PartyId;
+import geniusweb.deadline.Deadline;
+import geniusweb.deadline.DeadlineTime;
+import geniusweb.inform.Finished;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.protocol.session.TeamInfo;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyRef;
+import geniusweb.references.PartyWithParameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+import tudelft.utilities.logging.Reporter;
+import tudelft.utilities.repository.NoResourcesNowException;
+
+public class LearnTest {
+
+	private final Reporter reporter = mock(Reporter.class);
+	private Parameters params = new Parameters();
+	private Deadline deadline = new DeadlineTime(1800);
+	private PartyId party1id = new PartyId("party1");;
+	private PartyId party2id = new PartyId("party2");;
+	private final ProtocolToPartyConn conn1 = mock(ProtocolToPartyConn.class),
+			conn2 = mock(ProtocolToPartyConn.class);
+
+	@Before
+	public void before() {
+		params = params.with("persistentstate",
+				"6bb5f909-0079-43ac-a8ac-a31794391074");
+		params = params.with("negotiationdata",
+				Arrays.asList("12b5f909-0079-43ac-a8ac-a31794391012"));
+
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void smokeTest() {
+		new Learn(mock(LearnState.class), mock(Reporter.class));
+	}
+
+	@Test
+	public void getDescrTest() {
+		Learn l = new Learn(mock(LearnState.class), mock(Reporter.class));
+
+		assertNotNull(l.getDescription());
+	}
+
+	@Test
+	public void getStateTest() {
+		LearnState state = mock(LearnState.class);
+		Learn l = new Learn(state, mock(Reporter.class));
+		assertEquals(state, l.getState());
+	}
+
+	@Test
+	public void getRefTest() {
+		Learn l = new Learn(mock(LearnState.class), mock(Reporter.class));
+		assertEquals("Learn", l.getRef().getURI().getPath().toString());
+	}
+
+	@Test
+	public void finalStateNotificationTest() {
+		// check that listeners get notified when session ends.
+
+	}
+
+	@Test
+	public void testStartStopBasic() throws IOException,
+			NoResourcesNowException, InterruptedException, URISyntaxException {
+		Learn learn = createBasicLearn();
+		ProtocolToPartyConnFactory factory = createFactory();
+		learn.start(factory);
+		assertFalse(learn.getState().isFinal(System.currentTimeMillis()));
+		Thread.sleep(2000);
+		assertTrue(learn.getState().isFinal(System.currentTimeMillis()));
+	}
+
+	@Test
+	public void testStartStopLearn() throws IOException,
+			NoResourcesNowException, InterruptedException, URISyntaxException {
+		Learn learn = createBasicLearn();
+		ProtocolToPartyConnFactory factory = createFactory();
+		learn.start(factory);
+		assertFalse(learn.getState().isFinal(System.currentTimeMillis()));
+
+		// Instead of mocking connectin we call actionRequest directly
+		learn.actionRequest(conn1, new LearningDone(party1id));
+		assertFalse(learn.getState().isFinal(System.currentTimeMillis()));
+		learn.actionRequest(conn2, new LearningDone(party2id));
+		assertTrue(learn.getState().isFinal(System.currentTimeMillis()));
+	}
+
+	@Test(expected = IllegalStateException.class)
+	public void testAddParty() {
+		Learn l = new Learn(mock(LearnState.class), mock(Reporter.class));
+		l.addParticipant(mock(PartyWithProfile.class));
+	}
+
+	@Test
+	public void isFinishSentNormally()
+			throws URISyntaxException, IOException, NoResourcesNowException {
+		Learn learn = createBasicLearn();
+		ProtocolToPartyConnFactory factory = createFactory();
+		learn.start(factory);
+		learn.actionRequest(conn1, new LearningDone(party1id));
+		learn.actionRequest(conn2, new LearningDone(party2id));
+		verify(conn1, times(1)).send(isA(Finished.class));
+		verify(conn2, times(1)).send(isA(Finished.class));
+	}
+
+	@Test
+	public void isFinishSentInError()
+			throws URISyntaxException, IOException, NoResourcesNowException {
+		Learn learn = createBasicLearn();
+		ProtocolToPartyConnFactory factory = createFactory();
+		learn.start(factory);
+		learn.actionRequest(conn1, new EndNegotiation(party1id));
+		verify(conn1, times(1)).send(isA(Finished.class));
+		verify(conn2, times(1)).send(isA(Finished.class));
+	}
+
+	private Learn createBasicLearn() throws URISyntaxException {
+		TeamInfo team1 = createTeam(1);
+		TeamInfo team2 = createTeam(2);
+		LearnSettings settings = new LearnSettings(Arrays.asList(team1, team2),
+				deadline);
+		return (Learn) settings.getProtocol(reporter);
+
+	}
+
+	private TeamInfo createTeam(int nr) throws URISyntaxException {
+		PartyRef party1ref = new PartyRef("party" + nr);
+		PartyWithParameters party1 = new PartyWithParameters(party1ref, params);
+		ProfileRef profile1 = new ProfileRef("prof" + nr);
+		PartyWithProfile partywithp1 = new PartyWithProfile(party1, profile1);
+		List<PartyWithProfile> team1pp = Arrays.asList(partywithp1);
+		TeamInfo team = new TeamInfo(team1pp);
+		return team;
+	}
+
+	private ProtocolToPartyConnFactory createFactory()
+			throws IOException, NoResourcesNowException {
+		when(conn1.getParty()).thenReturn(party1id);
+		when(conn2.getParty()).thenReturn(party2id);
+
+		ProtocolToPartyConnFactory factory = mock(
+				ProtocolToPartyConnFactory.class);
+		// connections = mock(List.class);
+		List<ProtocolToPartyConn> connections = Arrays.asList(conn1, conn2);
+		when(factory.connect(any(List.class))).thenReturn(connections);
+		return factory;
+	}
+
+}
Index: protocol/src/test/java/geniusweb/protocol/session/mopac/MOPACStateTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/mopac/MOPACStateTest.java	(revision 30)
+++ protocol/src/test/java/geniusweb/protocol/session/mopac/MOPACStateTest.java	(revision 31)
@@ -79,5 +79,5 @@
 	public void before()
 			throws JsonParseException, JsonMappingException, IOException {
-		params1.put("power", 2);
+		params1 = params1.with("power", 2);
 		when(partyparams1.getParameters()).thenReturn(params1);
 
Index: protocol/src/test/java/geniusweb/protocol/session/mopac2/MOPAC2StateTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/mopac2/MOPAC2StateTest.java	(revision 30)
+++ protocol/src/test/java/geniusweb/protocol/session/mopac2/MOPAC2StateTest.java	(revision 31)
@@ -83,5 +83,5 @@
 	public void before()
 			throws JsonParseException, JsonMappingException, IOException {
-		params1.put("power", 2);
+		params1 = params1.with("power", 2);
 		when(partyparams1.getParameters()).thenReturn(params1);
 
Index: protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 30)
+++ protocol/src/test/java/geniusweb/protocol/session/saop/SAOPStateTest.java	(revision 31)
@@ -28,6 +28,5 @@
 import geniusweb.protocol.ProtocolException;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
-import geniusweb.protocol.session.SessionSettings;
+import geniusweb.references.PartyWithProfile;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -46,15 +45,12 @@
 	private ProtocolToPartyConn party3conn = mock(ProtocolToPartyConn.class);
 
-	private ProtocolToPartyConnections connections = new ProtocolToPartyConnections(
-			Arrays.asList(party1conn, party2conn));
-	private ProtocolToPartyConnections connections2 = new ProtocolToPartyConnections(
-			Arrays.asList(party1conn, party3conn));
-	private ProtocolToPartyConnections connections3 = new ProtocolToPartyConnections(
-			Arrays.asList(party1conn, party2conn, party3conn));
+	private List<PartyId> connections = Arrays.asList(party1, party2);
+	private List<PartyId> connections2 = Arrays.asList(party1, party3);
+	private List<PartyId> connections3 = Arrays.asList(party1, party2, party3);
 
 	private Progress progresstime = mock(ProgressTime.class);
 	private ProgressRounds progressrounds = mock(ProgressRounds.class);
 	private ProgressRounds progressrounds1 = mock(ProgressRounds.class);
-	private SessionSettings settings = mock(SAOPSettings.class);
+	private SAOPSettings settings = mock(SAOPSettings.class);
 	private SAOPState state1, state1a, state2, state3, state4;
 
@@ -106,14 +102,14 @@
 	public List<String> getGeneralTestStrings() {
 		return Arrays.asList(
-				"SAOPState.*\\[\\].*ConnectionWithParties.*conn1.*conn2.*ProgressTime.*",
-				"SAOPState.*\\[act1\\].*ConnectionWithParties.*conn1.*conn2.*ProgressTime.*",
-				"SAOPState.*ConnectionWithParties.*conn1.*conn3.*ProgressTime.*",
-				"SAOPState.*ConnectionWithParties.*conn1.*conn2.*ProgressRounds.*");
+				"SAOPState.*\\[\\].*party1.*party2.*ProgressTime.*",
+				"SAOPState.*\\[act1\\].*party1.*party2.*ProgressTime.*",
+				"SAOPState.*party1.*party3.*ProgressTime.*",
+				"SAOPState.*party1.*party2.*ProgressRounds.*");
 	}
 
 	@Test
 	public void constructWith0Connection() {
-		new SAOPState(actions, new ProtocolToPartyConnections(Arrays.asList()),
-				progresstime, settings, null, null);
+		new SAOPState(actions, Arrays.asList(), progresstime, settings, null,
+				null);
 	}
 
@@ -132,6 +128,5 @@
 	@Test
 	public void testNextActor2() {
-		ProtocolToPartyConnections conns = new ProtocolToPartyConnections(
-				Arrays.asList(party2conn, party3conn));
+		List<PartyId> conns = Arrays.asList(party2, party3);
 		SAOPState state = new SAOPState(actions, conns, progresstime, settings,
 				null, null);
@@ -237,5 +232,5 @@
 	@Test
 	public void withConnectionTest() {
-		SAOPState state = state1.with(party3conn, null);
+		SAOPState state = state1.with(party3, (PartyWithProfile) null);
 		assertEquals(3, state.getConnections().size());
 	}
@@ -274,8 +269,4 @@
 
 		state.with(party1, offer1);
-//		assertTrue(state.isFinal(NOW));
-//		assertEquals(
-//				"geniusweb.protocol.ProtocolException: party1:Party does not have the turn ",
-//				state.getError().toString());
 	}
 
@@ -297,5 +288,5 @@
 				settings, null, null);
 
-		state = state.with(party2, null);
+		state = state.with(party2, (Action) null);
 	}
 
Index: protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java	(revision 30)
+++ protocol/src/test/java/geniusweb/protocol/session/saop/SAOPTest.java	(revision 31)
@@ -6,4 +6,5 @@
 import static org.mockito.Matchers.anyLong;
 import static org.mockito.Matchers.eq;
+import static org.mockito.Matchers.isA;
 import static org.mockito.Mockito.doThrow;
 import static org.mockito.Mockito.mock;
@@ -34,7 +35,7 @@
 import geniusweb.events.CurrentState;
 import geniusweb.events.ProtocolEvent;
+import geniusweb.inform.ActionDone;
 import geniusweb.inform.Agreements;
 import geniusweb.inform.Finished;
-import geniusweb.inform.Inform;
 import geniusweb.inform.Settings;
 import geniusweb.inform.YourTurn;
@@ -80,5 +81,5 @@
 	private SAOP saop;
 	private ProtocolToPartyConnFactory factory;
-	private List connections;
+	private List<ProtocolToPartyConn> connections;
 	private ProtocolToPartyConn conn1 = mock(ProtocolToPartyConn.class),
 			conn2 = mock(ProtocolToPartyConn.class);
@@ -87,6 +88,7 @@
 	private ProfileRef profile1;
 	private ProfileRef profile2;
-	private ProtocolToPartyConnections connectionswithparties = mock(
-			ProtocolToPartyConnections.class);;
+	private ProtocolToPartyConnections connectionswithparties;// = new
+																// ProtocolTmock(
+																// ProtocolToPartyConnections.class);;
 	@SuppressWarnings("unchecked")
 	private final Listener<ProtocolEvent> testlistener = mock(Listener.class);
@@ -128,5 +130,6 @@
 
 		factory = mock(ProtocolToPartyConnFactory.class);
-		connections = mock(List.class);
+		// connections = mock(List.class);
+		connections = Arrays.asList(conn1, conn2);
 		when(factory.connect(any(List.class))).thenReturn(connections);
 
@@ -143,18 +146,22 @@
 		when(failstate.isFinal(anyLong())).thenReturn(true);
 
-		when(connectionswithparties.get(eq(PARTY1ID))).thenReturn(conn1);
-		when(connectionswithparties.get(eq(PARTY2ID))).thenReturn(conn2);
+		connectionswithparties = new ProtocolToPartyConnections(
+				Arrays.asList(conn1, conn2));
+
+//		when(connectionswithparties.get(eq(PARTY1ID))).thenReturn(conn1);
+//		when(connectionswithparties.get(eq(PARTY2ID))).thenReturn(conn2);
 		// HACK thenReturn twice, so that 2nd call to iterator() returns new
 		// iterator instead of the old one
-		when(connectionswithparties.iterator())
-				.thenReturn(Arrays.asList(conn1, conn2).iterator())
-				.thenReturn(Arrays.asList(conn1, conn2).iterator());
-		saop = new SAOP(state, new ReportToLogger("test"));
-		saop.addListener(testlistener);
-
+//		when(connectionswithparties.iterator())
+//				.thenReturn(Arrays.asList(conn1, conn2).iterator())
+//				.thenReturn(Arrays.asList(conn1, conn2).iterator());
 		Map<PartyId, PartyWithProfile> profilesmap = new HashMap<>();
 		profilesmap.put(PARTY1ID, pwp1);
 		profilesmap.put(PARTY2ID, pwp2);
 		when(state.getPartyProfiles()).thenReturn(profilesmap);
+
+		saop = new SAOP(state, new ReportToLogger("test"),
+				connectionswithparties);
+		saop.addListener(testlistener);
 
 	}
@@ -168,9 +175,13 @@
 	private void mockState(SAOPState state, String asText) {
 		when(state.getSettings()).thenReturn(settings);
-		when(state.getConnections()).thenReturn(connectionswithparties);
+		when(state.getConnections())
+				.thenReturn(Arrays.asList(PARTY1ID, PARTY2ID));
+		// when(state.getConnections()).thenReturn(connectionswithparties);
 
 		when(state.getProgress()).thenReturn(progress);
-		when(state.with(any(ProtocolToPartyConn.class),
-				any(PartyWithProfile.class))).thenReturn(connectedstate);
+		when(state.with(any(PartyId.class), any(PartyWithProfile.class)))
+				.thenReturn(connectedstate);
+//		when(state.with(any(ProtocolToPartyConn.class),
+//				any(PartyWithProfile.class))).thenReturn(connectedstate);
 		when(state.getNextActor()).thenReturn(PARTY1ID);
 		when(state.with(any(PartyId.class), any(EndNegotiation.class)))
@@ -192,5 +203,5 @@
 		when(set.getDeadline()).thenReturn(dl);
 		when(dl.getDuration()).thenReturn(1000l);
-		new SAOP(state1, new ReportToLogger("test"));
+		new SAOP(state1, new ReportToLogger("test"), connectionswithparties);
 		verify(state1, times(0)).with(any(ProtocolException.class));
 		verify(testlistener, times(0)).notifyChange(any(CurrentState.class));
@@ -281,14 +292,16 @@
 		verify(state, times(0)).with(any(ProtocolException.class));
 		verify(state, times(1)).with(eq(PARTY1ID), any(EndNegotiation.class));
-		verify(connectionswithparties, times(1)).broadcast(any(Inform.class));
+		// verify broadcast
+		verify(conn1, times(1)).send(isA(ActionDone.class));
+		verify(conn2, times(1)).send(isA(ActionDone.class));
 
 		// state.getNextActor() is frozen to PARTY1 by our mocking
-		verify(conn1, times(1)).send(any(YourTurn.class));
-		verify(conn2, times(0)).send(any(YourTurn.class));
-		verify(testlistener, times(0)).notifyChange(any(CurrentState.class));
-	}
-
-	@Test
-	public void testFinalActionRequest() throws IOException {
+		verify(conn1, times(1)).send(isA(YourTurn.class));
+		verify(conn2, times(0)).send(isA(YourTurn.class));
+		verify(testlistener, times(0)).notifyChange(any(CurrentState.class));
+	}
+
+	@Test
+	public void testFinalActionRequest() throws IOException, ProtocolException {
 		when(state.getNextActor()).thenReturn(PARTY1ID);
 		when(state.with(any(PartyId.class), any(EndNegotiation.class)))
@@ -296,13 +309,16 @@
 		// when(finalstate.getAgreements()).thenReturn(mock(Agreements.class));
 
+		saop.nextTurn(); // ensure we send YourTurn to party1.
 		saop.actionRequest(conn1, mock(EndNegotiation.class));
 
 		verify(state, times(0)).with(any(ProtocolException.class));
 		verify(state, times(1)).with(eq(PARTY1ID), any(EndNegotiation.class));
-		verify(connectionswithparties, times(1)).broadcast(any(Finished.class));
+		// verify broadcast
+		verify(conn1, times(1)).send(isA(Finished.class));
+		verify(conn2, times(1)).send(isA(Finished.class));
 		verify(testlistener, times(1)).notifyChange(any(CurrentState.class));
 
-		verify(conn1, times(1)).send(any(YourTurn.class));
-		verify(conn2, times(1)).send(any(YourTurn.class));
+		verify(conn1, times(1)).send(isA(YourTurn.class));
+		verify(conn2, times(0)).send(isA(YourTurn.class));
 	}
 
@@ -339,5 +355,6 @@
 	@Test
 	public void testActionInFinalState() throws IOException {
-		saop = new SAOP(finalstate, new ReportToLogger("test"));
+		saop = new SAOP(finalstate, new ReportToLogger("test"),
+				connectionswithparties);
 		// when(finalstate.getAgreements()).thenReturn(mock(Agreements.class));
 
Index: protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java	(revision 30)
+++ protocol/src/test/java/geniusweb/protocol/session/saop/SaopPartyWithProfileTest.java	(revision 31)
@@ -43,6 +43,5 @@
 
 		Parameters settings1 = new Parameters();
-		Parameters settings2 = new Parameters();
-		settings2.put("a", 1);
+		Parameters settings2 = new Parameters().with("a", 1);
 
 		PartyWithParameters party1withparams1 = new PartyWithParameters(party1,
Index: protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettingsTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettingsTest.java	(revision 30)
+++ protocol/src/test/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettingsTest.java	(revision 31)
@@ -19,4 +19,6 @@
 import geniusweb.protocol.NegoSettings;
 import geniusweb.protocol.session.saop.SAOPSettings;
+import geniusweb.protocol.tournament.ProfileList;
+import geniusweb.protocol.tournament.Team;
 import geniusweb.protocol.tournament.TournamentSettings;
 import geniusweb.references.Parameters;
Index: protocol/src/test/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnProtocolTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnProtocolTest.java	(revision 31)
+++ protocol/src/test/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnProtocolTest.java	(revision 31)
@@ -0,0 +1,184 @@
+package geniusweb.protocol.tournament.allpermutationslearn;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertNull;
+import static org.mockito.Matchers.any;
+import static org.mockito.Matchers.anyLong;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.times;
+import static org.mockito.Mockito.verify;
+import static org.mockito.Mockito.when;
+
+import java.math.BigInteger;
+import java.util.LinkedList;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+import org.mockito.ArgumentCaptor;
+
+import geniusweb.events.ProtocolEvent;
+import geniusweb.inform.Agreements;
+import geniusweb.protocol.CurrentNegoState;
+import geniusweb.protocol.NegoState;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.protocol.session.SessionProtocol;
+import geniusweb.protocol.session.SessionResult;
+import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.SessionState;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProtocolRef;
+import tudelft.utilities.listener.Listener;
+import tudelft.utilities.logging.ReportToLogger;
+
+public class AllPermutationsLearnProtocolTest {
+
+	private final AllPermutationsLearnState state = mock(
+			AllPermutationsLearnState.class),
+			newstate = mock(AllPermutationsLearnState.class);
+	private final ReportToLogger log = new ReportToLogger("test");
+	private final AllPermutationsLearnProtocol app = new AllPermutationsLearnProtocol(
+			state, log);
+	private final ProtocolToPartyConnFactory factory = mock(
+			ProtocolToPartyConnFactory.class);
+	private final SessionSettings settings = mock(SessionSettings.class);
+	private final SessionState finalsessionstate = mock(SessionState.class);
+	private Agreements agreement = mock(Agreements.class);
+	private final long NOW = 1000;
+	private SessionResult finalstate = mock(SessionResult.class);
+
+	@Before
+	public void before() {
+		when(state.getSize()).thenReturn(BigInteger.ZERO);
+		when(finalsessionstate.isFinal(anyLong())).thenReturn(true);
+		when(finalsessionstate.getSettings()).thenReturn(settings);
+		when(finalsessionstate.getAgreements()).thenReturn(agreement);
+		when(finalsessionstate.getResult()).thenReturn(finalstate);
+		when(finalstate.getAgreements()).thenReturn(agreement);
+		when(state.with(any())).thenReturn(newstate);
+	}
+
+	@Test
+	public void smokeTest() {
+	}
+
+	@Test
+	public void startTestNoSessions() {
+		AllPermutationsLearnProtocol app = new AllPermutationsLearnProtocol(
+				state, log);
+		app.start(factory);
+
+	}
+
+	@Test
+	public void getDescrTest() {
+		assertNotNull(app.getDescription());
+	}
+
+	@Test
+	public void getStateTest() {
+		assertEquals(state, app.getState());
+	}
+
+	@Test
+	public void getRefTest() {
+		assertEquals("APPLearn", app.getRef().getURI().toString());
+	}
+
+	@Test
+	public void runOneSessionTest() throws InterruptedException {
+		MockSessionProtocol sessionprotocol = startSession();
+		sessionprotocol.getListener();
+	}
+
+	@Test
+	public void runOneSessionAndUnhandledEvent() throws InterruptedException {
+		MockSessionProtocol sessionprotocol = startSession();
+		sessionprotocol.getListener().notifyChange(mock(ProtocolEvent.class));
+		verify(state, times(0)).with(any());
+	}
+
+	/**
+	 * Check that a started session correctly handles a session event.
+	 */
+	@Test
+	public void CurrentNegoStateEventTest() throws InterruptedException {
+		MockSessionProtocol sessionprotocol = startSession();
+
+		CurrentNegoState evt = mock(CurrentNegoState.class);
+		when(evt.getState()).thenReturn(finalsessionstate);
+		sessionprotocol.getListener().notifyChange(evt);
+
+		ArgumentCaptor<SessionResult> argument = ArgumentCaptor
+				.forClass(SessionResult.class);
+		verify(state, times(1)).with(argument.capture());
+		assertEquals(agreement, argument.getValue().getAgreements());
+		assertNull(argument.getValue().getError());
+	}
+
+	private MockSessionProtocol startSession() throws InterruptedException {
+		SessionSettings setting = mock(SessionSettings.class);
+		MockSessionProtocol sessionprotocol = new MockSessionProtocol();
+		when(setting.getProtocol(log)).thenReturn(sessionprotocol);
+		when(state.getNextSettings()).thenReturn(setting);
+
+		app.start(factory);
+		Thread.sleep(500); // allow app to start session
+		// this call should return fine, and have listener registered to our
+		// protocol. app now waits for a notification
+		return sessionprotocol;
+	}
+
+}
+
+/**
+ * 
+ * The protocol needs to record the listners, we need a listener to trigger
+ * further protocol actions. Mockito can't handle this, we mneed our own mock...
+ *
+ */
+class MockSessionProtocol implements SessionProtocol {
+	private final List<Listener<ProtocolEvent>> listeners = new LinkedList<>();
+
+	@Override
+	public void start(ProtocolToPartyConnFactory connectionfactory) {
+
+	}
+
+	@Override
+	public String getDescription() {
+		return null;
+	}
+
+	@Override
+	public NegoState getState() {
+		return null;
+	}
+
+	@Override
+	public ProtocolRef getRef() {
+		return null;
+	}
+
+	@Override
+	public void addParticipant(PartyWithProfile party) {
+	}
+
+	@Override
+	public void addListener(Listener<ProtocolEvent> l) {
+		listeners.add(l);
+	}
+
+	@Override
+	public void removeListener(Listener<ProtocolEvent> l) {
+	}
+
+	public Listener<ProtocolEvent> getListener() {
+		if (listeners.size() != 1) {
+			throw new IllegalStateException("Not having exactly 1 listener");
+		}
+		return listeners.get(0);
+	}
+
+}
